function loadPage(url) {
    window.location = url;
}


window.onload = function() {
    //TFGraphInit("tfcanvasContainer", "tfcanvas");
    // localStorage.removeItem('srcfile')    
};

function fileUpload(mode, that) {
    console.log("mode", mode);
    var scope = angular.element(that).scope().pathchange(mode);
}

var debug;

////////////////////////////////////////////
// AngularJS Module and Controller        //
////////////////////////////////////////////
angular.module('harktool', ["ui.bootstrap"]).controller('mainMenuCtrl', function($scope, $uibModal) {
    $scope.path = "";
    $scope.type = "";

    $scope.micfile = localStorage.getItem('micfile');
    $scope.srcfile = localStorage.getItem('srcfile');
    $scope.tffile = localStorage.getItem('tffile');
    $scope.micErr = localStorage.getItem('micfileerr');
    $scope.srcErr = localStorage.getItem('srcfileerr');
    $scope.tfErr = localStorage.getItem('tffileerr');

    $scope.pathchange = function(mode) {
        var filepath = $('#' + mode + 'file').val();
        console.log("filepath=", filepath);
        var regex = /\\|\\/;
        var path = filepath.split(regex);
        var filename = path[path.length - 1];
        console.log("filename=", filename);
        $scope[mode + 'file'] = filename;

        $.ajax({
            url: "/file/" + mode,
            method: "POST",
            cache: false,
            contentType: false,
            processData: false,
            data: new FormData($("#" + mode + "form")[0]),
            timeout: 10000
        }).done(function(e) {
            setValidSuccess(mode, filename, e);
            $scope[mode + "ok"]();
            $('#' + mode + 'file').val(""); // 同名fileを再度uploadできるようにするworkaround
            $scope.$apply();
        }).fail(function(e) {
            var errorMsg = (e.responseText) ? e.responseText : e.statusText;
            setValidError(mode, filename, errorMsg);
            $scope[mode + 'Err'] = errorMsg;
            $scope[mode + "ng"]();
            $('#' + mode + 'file').val(""); // 同名fileを再度uploadできるようにするworkaround
            $scope.showmd(errorMsg);
            $scope.$apply();
        });
        // $("#" + mode + "submit").click();
    };

    $scope.buttonCreate = function(mode) {
        // mode must be mic/src/tf
        window.location.href = '/' + mode + 'gen';
    };

    $scope.buttonDownload = function(file) {
        window.location.href = '/file/' + file;
    };

    $scope.buttonVisualize = function(mode) {
        // mode must be mic/src/tf
        window.location.href = '/' + mode + 'plot';
    };

    $scope.micAndSrcErr = null;
    $scope.showmd = function(msg) {
        if (!msg)
            return;
        $scope.msg = msg;
        $uibModal.open({
            templateUrl: 'T_errorDialog',
            scope: $scope
        });
    };

    // OK/NG status
    $scope.micandsrc = false;
    $scope.status = { mic: {}, src: {}, tf: {} };

    $scope.micok = function() {
        $scope.status.mic = ["glyphicon-ok", "statok"];
        $scope.status.mic.ok = true;
        $scope.micandsrc = $scope.checkMicAndSrc();
    };
    $scope.micng = function() {
        $scope.status.mic = ["glyphicon-remove", "statng"];
        $scope.status.mic.ok = false;
        $scope.micandsrc = $scope.checkMicAndSrc();
    };
    $scope.srcok = function() {
        $scope.status.src = ["glyphicon-ok", "statok"];
        $scope.status.src.ok = true;
        $scope.micandsrc = $scope.checkMicAndSrc();
    };
    $scope.srcng = function() {
        $scope.status.src = ["glyphicon-remove", "statng"];
        $scope.status.src.ok = false;
        $scope.micandsrc = $scope.checkMicAndSrc();
    };
    $scope.tfok = function() {
        $scope.status.tf = ["glyphicon-ok", "statok"];
        $scope.status.tf.ok = true;
    };
    $scope.tfng = function() {
        $scope.status.tf = ["glyphicon-remove", "statng"];
        $scope.status.tf.ok = false;
    };
    $scope.checkMicAndSrc = function() {
        if ($scope.status.mic.ok && $scope.status.src.ok) {
            // channnel check
            var micChannels = JSON.parse(localStorage.getItem('micfileinfo')).channels;
            var srcChannels = JSON.parse(localStorage.getItem('srcfileinfo')).channels;
            if (srcChannels) {
                var notHaveChannels = [];
                for (var srcCh in srcChannels) {
                    var hasCh = false;
                    for (var micCh in micChannels) {
                        if (srcCh == micCh) {
                            hasCh = true;
                            break;
                        }
                    }
                    if (!hasCh)
                        notHaveChannels.push(srcCh);
                }
                if (notHaveChannels.length > 0) {
                    $scope.micAndSrcErr = "Channels " + notHaveChannels + " not found in " + $scope.micfile;
                    $scope.showmd($scope.micAndSrcErr);
                    return false;
                }
            }
            $scope.micAndSrcErr = null;
            return true;
        }
        $scope.micAndSrcErr = null;
        return false;
    };

    if ($scope.micfile) {
        if (localStorage.getItem('micfileinfo'))
            $scope.micok();
        else
            $scope.micng();
    }

    if ($scope.srcfile) {
        if (localStorage.getItem('srcfileinfo'))
            $scope.srcok();
        else
            $scope.srcng();
    }

    if ($scope.tffile) {
        if (localStorage.getItem('tffileinfo'))
            $scope.tfok();
        else
            $scope.tfng();
    }
});
